#ifndef C_MSG_DEF__
#define C_MSG_DEF__

#include "DefCommon.h"
#include "DefSwitch.h"
#include "DefDisk.h"

//definition for switch position
#define SW_POSITION_NORMAL		'n'		//switch position - normal
#define SW_POSITION_REVERSE		'r'		//switch position - reverse
#define SW_POSITION_NO			'o'		//switch position - no position
//definition for switch status
#define SW_STATUS_IDLE			0x0000		//switch status - idle status
#define SW_STATUS_FAIL			0x0001		//switch status - fail status
#define SW_STATUS_ROUTE_LOCK		0x0002		//switch status - route lock status
#define SW_STATUS_TKOCC_LOCK		0x0004		//switch status - tkocc lock status
#define SW_STATUS_MAN_LOCK		0x0008		//switch status - manual lock status
#define SW_STATUS_TRANSIT		0x0010		//switch status - transit status
#define SW_STATUS_POS_LOCK		0x0020		//switch status - position lock status
#define SW_STATUS_FLD_LOCK		0x0040		//switch status - field people lock switch status
#define SW_STATUS_BLOCK			0x0080		//switch status - block switch status
#define SW_STATUS_SIG_BLOCK		0x0100		//switch status - locked by a trim signal status
#define SW_STATUS_MACHINE_FAULT		0x0200		//switch status - switch machine fault status
#define SW_STATUS_LIGHT_FAULT		0x0400		//switch status - switch light fault status

//definition for config
#define CONFIG_INPUT			'I'		//config - indicates pin is input
#define CONFIG_OUTPUT			'O'		//config - indicates pin is output
#define CONFIG_DEV_SWITCH		'S'		//config - indicates device is Switch
#define CONFIG_DEV_PD			'P'		//config - indicates device is PD
#define CONFIG_DEV_MISC			'Y'		//config - indicates device is Misc
#define CONFIG_DEV_SIGNAL		'I'		//config - indicates device is Signal

//definition for switch input
#define CONFIG_INPUT_SW_CTL_STD_NOR	'A'		//input - switch control standard input: normal
#define CONFIG_INPUT_SW_CTL_STD_REV	'B'		//input - switch control standard input: reverse
#define CONFIG_INPUT_SW_CTL_STD_TGL	'C'		//input - switch control standard input: toggle
#define CONFIG_INPUT_SW_CTL_AUX_NOR	'D'		//input - switch control auxiliary input: normal
#define CONFIG_INPUT_SW_CTL_AUX_REV	'E'		//input - switch control auxiliary input: reverse
#define CONFIG_INPUT_SW_CTL_AUX_TGL	'F'		//input - switch control auxiliary input: toggle
#define CONFIG_INPUT_SW_IND_STD_NOR	'G'		//input - switch indication standard input: normal
#define CONFIG_INPUT_SW_IND_STD_REV	'H'		//input - switch indication standard input: reverse
#define CONFIG_INPUT_SW_IND_AUX_NOR	'I'		//input - switch indication auxiliary input: normal
#define CONFIG_INPUT_SW_IND_AUX_REV	'J'		//input - switch indication auxiliary input: reverse
#define CONFIG_INPUT_SW_LOCKOUT		'K'		//input - lockout input
#define CONFIG_INPUT_SW_OCC		'L'		//input - occupancy input
#define CONFIG_INPUT_SW_PRESSURE	'M'		//input - pressure switch input
#define CONFIG_INPUT_SW_POWER_LEVER	'N'		//input - power/hand lever input

//definition for pd input
#define CONFIG_INPUT_PD_1		'A'		//input - pd1 input
#define CONFIG_INPUT_PD_2		'B'		//input - pd2 input
#define CONFIG_INPUT_PD_3		'C'		//input - pd3 input
#define CONFIG_INPUT_PD_4		'D'		//input - pd4 input

//definition for misc input
#define CONFIG_INPUT_MISC_SPARE		'Z'		//input - spare

//definition for signal input
#define CONFIG_INPUT_SIG_LIGHTOUT_1	'A'		//input - signal input: light out 1
#define CONFIG_INPUT_SIG_LIGHTOUT_2	'B'		//input - signal input: light out 2
#define CONFIG_INPUT_SIG_LIGHTOUT_3	'C'		//input - signal input: light out 3
#define CONFIG_INPUT_SIG_LIGHTOUT_4	'D'		//input - signal input: light out 4

//definition for switch output
#define CONFIG_OUTPUT_SW_NOR		'A'		//output - normal control
#define CONFIG_OUTPUT_SW_REV		'B'		//output - reverse control
#define CONFIG_OUTPUT_SW_MOTOR		'C'		//output - motor control
#define CONFIG_OUTPUT_SW_MACH_DISABLE	'D'		//output - machine disable
#define CONFIG_OUTPUT_SW_MACH_FAULT	'E'		//output - machine fault

//definition for pd output
#define CONFIG_OUTPUT_PD_SPARE		'Z'		//output - pd spare

//definition for misc output
#define CONFIG_OUTPUT_MISC_COMM_FAULT	'A'		//output - misc output: communication fault
#define CONFIG_OUTPUT_MISC_BAT_LOW	'B'		//output - misc output: battery low
#define CONFIG_OUTPUT_MISC_BAT_OK	'C'		//output - misc output: battery ok
#define CONFIG_OUTPUT_MISC_SPARE	'Z'		//output - misc output: spare

//definition for signal output
#define CONFIG_OUTPUT_SIG_NOR		'A'		//output - signal output: normal
#define CONFIG_OUTPUT_SIG_REV		'B'		//output - signal output: reverse
#define CONFIG_OUTPUT_SIG_NO_POS	'C'		//output - signal output: no position
#define CONFIG_OUTPUT_SIG_BLUE_LIGHT	'D'		//output - signal output: blue light
#define CONFIG_OUTPUT_SIG_STROBE_LIGHT	'E'		//output - signal output: strobe light


//definition of all message
#define MSG_BROADCAST			0x0001		//message - broadcast message to all
#define MSG_REQUEST			0x0010		//message - request status message
#define MSG_SWITCH_STATUS		0x0020		//message - request switch status message
#define MSG_SIGNAL_STATUS		0x0021		//message - request signal status message
#define MSG_LCP_STATUS			0x0023		//message - switch assessment of LCP(link control protocol) status
#define MSG_EVENT_ACK			0x0030		//message - acknowledge message
#define MSG_SWITCH_EVENT		0x0040		//message - switch event message
#define MSG_SWITCH_TOGGLE_REQ		0x0043		//message - switch toggle request
#define MSG_SWITCH_COMMAND		0x0050		//message - switch command
#define MSG_SWITCH_COMMAND_ACK		0x0060		//message - switch command acknowledgement message
#define MSG_COMMUNICATION_LOST		0x0090		//message - communication lost
#define MSG_COMMUNICATION_RECOVER	0x0091		//message - communication restored event

//definition of broadcst message.
#define SW_BC_NETWORK_IN_STANDBY	0x00		//broadcast - network in standby mode
#define SW_BC_INIT_BASE_STATION		0x01		//broadcast - base station is initializing
#define SW_BC_NETWORK_IN_CONTROL	0xFF		//broadcast - network in control mode

//definition of active switch control
#define SW_STATUS_ACTIVE_CTL_INVALID	0x00		//active switch control - invalid
#define SW_STATUS_ACTIVE_CTL_REVERSE	0x01		//active switch control - reverse
#define SW_STATUS_ACTIVE_CTL_NORMAL	0x02		//active switch control - normal

//definition of command status
#define SW_CMD_STATUS_IN_PROGRESS	0x00		//command status - accept, action in progress
#define SW_CMD_STATUS_SUCCESS		0x01		//command status - complete
#define SW_CMD_STATUS_REJECTED		0x02		//command status - rejected, other command in progress
#define SW_CMD_STATUS_FAILED		0x03		//command status - failed
#define SW_CMD_STATUS_NO_ACTION		0x04		//command status - no action
#define SW_CMD_STATUS_BATTERY_LOW	0x05		//command status - rejected, battery too low

//definition of switch indications
#define SW_INDICATION_A_REVERSE		0x01		//switch indication - switch A in reverse position
#define SW_INDICATION_A_NORMAL		0x02		//switch indication - switch A in normal position
#define SW_INDICATION_A_OCCUPIED	0x04		//switch indication - switch A is occupied
#define SW_INDICATION_A_LOCKOUT		0x08		//switch indication - switch A lockout
#define SW_INDICATION_B_REVERSE		0x10		//switch indication - switch B in reverse position
#define SW_INDICATION_B_NORMAL		0x20		//switch indication - switch B in normal position
#define SW_INDICATION_B_OCCUPIED	0x40		//switch indication - switch B is occupied
#define SW_INDICATION_B_LOCKOUT		0x80		//switch indication - switch B lockout

//definition of switch hardware status
#define SW_HARDWARE_STATUS_A_LOW_BAT	0x01		//switch hardware status - switch A battery low
#define SW_HARDWARE_STATUS_B_LOW_BAT	0x02		//switch hardware status - switch B battery low
#define SW_HARDWARE_STATUS_A_TIMEOUT	0x04		//switch hardware status - switch A move time out
#define SW_HARDWARE_STATUS_B_TIMEOUT	0x08		//switch hardware status - switch A move time out
#define SW_HARDWARE_STATUS_CROSS_FAIL	0x10		//switch hardware status - crossover switch serial communication failure
#define SW_HARDWARE_STATUS_A_MAC_FAULT	0x20		//switch hardware status - switch A machine fault
#define SW_HARDWARE_STATUS_B_MAC_FAULT	0x40		//switch hardware status - switch B machine fault

//definition of field toggle request
#define SW_FLD_TOGGLE_NO		0x00		//toggle - no request
#define SW_FLD_TOGGLE_YES		0x01		//toggle - has request

//definition of switch command
#define SW_COMMAND_INVALID		0x00		//switch command - invalid
#define SW_COMMAND_REVERSE		0x01		//switch command - reverse
#define SW_COMMAND_NORMAL		0x02		//switch command - normal

//definition of reason for communication lost and recover
#define SW_REASON_COMM_LOST_NO_BROAD	0x00		//     Lost - did not receive broadcast message
#define SW_REASON_COMM_LOST_NO_ACK	0x01		//     Lost - did not receive event acknowledgement message
#define SW_REASON_COMM_RECOVER_ACK	0x02		//Recovered - receive event acknowledgement message

//definition of signal indication
#define SW_SIGNAL_INDICATION_OFF	0x00		//signal indication - signal off
#define SW_SIGNAL_INDICATION_FLASH	0x01		//signal indication - signal flash/blink
#define SW_SIGNAL_INDICATION_ON		0x02		//signal indication - signal steady on

//definition of signal hardware status
#define SW_SIGNAL_HW_STATUS_BB		0x01		//signal hardware status - blown bulb indicated

//definition for timer message
#define MAX_NUM_TIME_MSG_QUEUE		(512 + 1)	//max time msg allowed to be stored in timecenter
#define MSG_MIN				0x6000		//min message number
#define MSG_MAX				0x7FFF		//maximum message number
#define TIMER_MSG_MIN			0x5600
#define TIMER_MSG_MAX			0x57FF
#define TIMER_MSG_TOTAL			0x1FF		//total 512 msg
#define MSG_TIMER_INPUT_DEBOUNCE	(MSG_MIN + 1626)//timer message for input debounce
#define MSG_TIMER_INPUT_IND_GAP		(MSG_MIN + 1627)//timer message for input standard indication gapped
#define MSG_TIMER_INPUT_DIS_THROW	(MSG_MIN + 1628)//timer message for input standard disable throw
#define MSG_TIMER_INPUT_LOCKOUT		(MSG_MIN + 1629)//timer message for disable throw after lockout disabled
#define MSG_TIMER_INPUT_OCC		(MSG_MIN + 1630)//timer message for disable throw after occupancy disabled
#define MSG_TIMER_INPUT_IND_GAP_A	(MSG_MIN + 1631)//timer message for input auxiliary indication gapped
#define MSG_TIMER_INPUT_DIS_THROW_A	(MSG_MIN + 1632)//timer message for input auxiliary disable throw
#define MSG_TIMER_LIGHT			(MSG_MIN + 1633)//timer message for light duration timer
#define MSG_TIMER_SELF_RESTORE		(MSG_MIN + 1634)//timer message for self restore timer
#define MSG_TIMER_PRESS_SW_DEBOUNCE	(MSG_MIN + 1635)//timer message for pressure switch debounce timer
#define MSG_TIMER_PRESS_SW_BKY		(MSG_MIN + 1636)//timer message for pressure switch breakaway timer
#define MSG_TIMER_PRESS_SW_INTR		(MSG_MIN + 1637)//timer message for pressure switch intermittent timer
#define MSG_TIMER_MAX_SW_RUN		(MSG_MIN + 1638)//timer message for switch maximum run time timer
#define MSG_TIMER_COIL			(MSG_MIN + 1639)//timer message for directional value coil delay
#define MSG_TIMER_LEVER			(MSG_MIN + 1640)//timer message for power lever delay

#define MAX_NUM_DISK_MSG_QUEUE		(256 + 1)	//max time msg allowed to be stored in timecenter
#define MSG_DISK_SW_STORE		(MSG_MIN + 1700)//disk message for store one switch message
#define MSG_DISK_SW_REMOVE		(MSG_MIN + 1700)//disk message for remove one switch message
#define MSG_DISK_SW_SAVE		(MSG_MIN + 1701)//disk message for save message to file

#define MSG_DEBUG_CSL			(MSG_MIN + 900) //only for csl 
//#define MSG_DEBUG_DTC			(MSG_MIN + 901) 
#define MSG_DEBUG_ROLLCUT		(MSG_MIN + 902) // for rollCut
#define MSG_DEBUG_RUNRET		(MSG_MIN + 903) // for runRet
#define MSG_DEBUG			(MSG_MIN + 905) // for everybody else



typedef struct MsgHeadearT
{
	short		type;
	long		subtype;
}msg_header_t;

//struct - timer delay message record
typedef struct TimerRec_Delay
{
	short		timerID;			// timer class such as switch, track, userReq 
	short		index;				// in relate to timerID, ex: if timerID is for switch, index = switch index
	short		subIndex;
	short		sendTo;				// send msg to this guy when timer expired 
	long		delaySec;
	long		delayNonoSec;
	char		charFlag1;
	char		charFlag2;
	char		charFlag3;
	char		charFlag4;			//a:timer started, b: timer expired
	int		intFlag1;
	int		intFlag2;
	int		intFlag3;
	float		floatFlag1;
	float		floatFlag2;
	long		longFlag1;
	long		longFlag2;
	long		longFlag3;
}TIME_DELAY_REC;

//struct - common message for communication of each center
typedef struct CommMsgInfo
{
	msg_header_t	hdr;				//here we borrow neutrino's define
	int		size;				//size of the message
	long		crestTime;			//any time use time()
	struct timespec	recTime;			//time of which this msg generate
	short		nodeNo;				//where the msg come from, if is 0, means ND_LOCAL_NODE
	char		nodeName[MAX_NODE_NAME_LEN];
	char		replay;				//this bit will be used for replay
	short		receiverID;			//which program will receive it
	short		senderID;			//which program send it
	pid_t		myPid;

	char		charFlag1;
	char		charFlag2;
	char		charFlag3;
	int		intFlag1;
	int		intFlag2;
	int		intFlag3;
	int		longFlag1;
	int		longFlag2;
	int		longFlag3;
	float		floatFlag1;
	float		floatFlag2;

	union
	{
		TIME_DELAY_REC timeDelayRec;
		SWITCH_DEF_DATA swRec;
		DISK_DEF_DATA diskRec;
	} ComMsg;
}COMMON_MSG_DATA;

//struct - timer message sending record
typedef struct TimerRec_MsgInfo
{
	msg_header_t	hdr;				//here we borrow neutrino's define
	struct timespec recTime;			//timer message time
	short		nodeNo;
	short		receiverID;			//which program send it
	short		senderID;			//which program receive it
	pid_t		myPid;
	TIME_DELAY_REC  timeDelayRec;
	COMMON_MSG_DATA comMsgRec;
}TIME_CENTER_MSG_DATA;

//struct - timecenter message queue
struct TimeMsgQueueElement
{
	short		code;				//msg id
	short		index;				//msg index
	TIME_CENTER_MSG_DATA msgStore;
	struct TimeMsgQueueElement *ahead;
	struct TimeMsgQueueElement *behind;
};

//struct header, all struct should use this header
typedef struct SwRec_Header
{
	int16_t 	netID;				//net ID
	int8_t		destNodeID;			//destination node ID
	int8_t		srcNodeID;			//source node ID
	int8_t		msgType;			//message type
	int16_t		msgSize;			//message size
	int32_t		timeSec;			//time second
	int32_t		timeNanaSec;			//time nanosecond
	int32_t		senderAddr;			//sender ip address
	int16_t		senderPort;			//sender ip port
	int32_t		rcvAddr;			//receive ip address
	int16_t		rcvPort;			//receive ip port
}SW_REC_HEADER;

//struct footer, all struct should use this footer
typedef struct SwRec_Footer
{
	int16_t		CRC;				//check message
}SW_REC_FOOTER;

//struct -  broadcast(0x01)
typedef struct SwRec_BroadCast
{
	//SW_REC_HEADER	swMsgHeader;			//message header
	int8_t		netStatus;			//0x00:standby; 0x01:init; 0xff:network in control mode
	SW_REC_FOOTER	swMsgFooter;			//message footer
}SW_REC_BROADCAST;

//struct - request status(0x10)
typedef struct SwRec_StatusReq
{
	//SW_REC_HEADER	swMsgHeader;			//message header
	int16_t		seqNo;				//sequence numbers
	int8_t		nodeID;				//node ID
	SW_REC_FOOTER	swMsgFooter;			//message footer
}SW_REC_STATUS_REQ;

//struct - request switch status(0x20)
typedef struct SwRec_SwitchStatus
{
	//SW_REC_HEADER	swMsgHeader;			//message header
	int16_t		seqNo;				//sequence numbers
	int8_t		activeSwCtl;			//active swtich control
	int8_t		cmdStatus;			//command status
	int8_t		swIndication;			//switch indications
	int8_t		swBatVolA;			//switch A battery voltage
	int8_t		swBatVolB;			//switch B battery voltage
	int8_t		swHardwareStatus;		//switch hardware status
	int8_t		swInfo;				//switch status reserved
	SW_REC_FOOTER	swMsgFooter;			//message footer
}SW_REC_SWITCH_STATUS;

//struct - acknowledge message(0x30)
typedef struct SwRec_EventAck
{
	SW_REC_HEADER	swMsgHeader;			//message header
	int16_t		seqNo;				//sequence numbers
	int8_t		status;				//event status
	SW_REC_FOOTER	swMsgFooter;			//message footer
}SW_REC_EVENT_ACK;

//struct - switch event message(0x40)
typedef struct SwRec_SwEvent
{
	//SW_REC_HEADER	swMsgHeader;			//message header
	int16_t		seqNo;				//sequence numbers
	int8_t		activeSwCtl;			//switch control
	int8_t		cmdStatus;			//command status
	int8_t		swIndication;			//switch indications
	int8_t		swBatVolA;			//switch A battery voltage
	int8_t		swBatVolB;			//switch B battery voltage
	int8_t		swHardwareStatus;		//switch hardware status
	int8_t		swInfo;				//switch status reserved
	SW_REC_FOOTER	swMsgFooter;			//message footer
}SW_REC_SWITCH_EVENT;

//struct - switch toggle request(0x43)
typedef struct SwRec_SwToggleReq
{
	//SW_REC_HEADER	swMsgHeader;			//message header
	int16_t		seqNo;				//sequence numbers
	int8_t		fldToggleReq;			//field toggle request
	int8_t		togInfo;			//toggle reserved
	SW_REC_FOOTER	swMsgFooter;			//message footer
}SW_REC_SWITCH_TOGGLE_REQ;

//struct - switch command(0x50)
typedef struct SwRec_SwCommand
{
	SW_REC_HEADER	swMsgHeader;			//message header
	int16_t		seqNo;				//sequence numbers
	int8_t		swCmd;				//switch command
	SW_REC_FOOTER	swMsgFooter;			//message footer
}SW_REC_SWTICH_COMMAND;

//struct - switch command acknowledge(0x60)
typedef struct SwRec_SwCmdAck
{
	SW_REC_HEADER	swMsgHeader;			//message header
	int16_t		seqNo;				//sequence numbers
	int8_t		activeSwCtl;			//switch control
	int8_t		cmdStatus;			//command status
	int8_t		swCmd;				//switch command
	int8_t		swIndication;			//switch indications
	int8_t		swCmdAckInfo;			//reserved
	SW_REC_FOOTER	swMsgFooter;			//message footer
}SW_REC_SWITCH_COMMAND_ACK;

//struct - communication lost(0x90)
typedef struct SwRec_CommLost
{
	int16_t		seqNo;				//sequence numbers
	int8_t		reason;				//reason for communication lost
	SW_REC_FOOTER	swMsgFooter;			//message footer
}SW_REC_COMM_LOST;

//struct - communication recovered(0x91)
typedef struct SwRec_CommRecovered
{
	int16_t		seqNo;				//sequence numbers
	int8_t		reason;				//reason for communication recovered
	SW_REC_FOOTER	swMsgFooter;			//message footer
}SW_REC_COMM_RECOVERED;

//struct - signal status message(0x21)
typedef struct SwRec_SignalStatus
{
	//SW_REC_HEADER	swMsgHeader;			//message header
	int16_t		seqNo;				//sequence numbers
	int8_t		activeSwCtl;			//switch control
	int8_t		cmdStatus;			//command status
	int8_t		sigIndication;			//signal indication
	int8_t		sigHardwareStatus;		//signal hardware status
	int8_t		sigBatVol;			//signal battery voltage
	int8_t		sigInfo;			//signal reserved
	SW_REC_FOOTER	swMsgFooter;			//message footer
}SW_REC_SIGNAL_STATUS;
#endif
